unit ColorMain;

interface

uses
  SysUtils, Forms,
  xorDX8;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    Scene: TxorDXScene;
    Camera: TxorDXCamera;
    Ball: TxorDXBall;
    procedure Draw(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  //creation
  Scene  := TxorDXScene.Create(Handle);
  Camera := TxorDXCamera.Create(Scene);
  Ball   := TxorDXBall.Create(Scene, 60, 30, 2); //set standard coordinates and colors
  Scene.CreateBuffers;

  //some simple graphics...
  //smiley
  Ball.Color[4, 5] := Ball.Color[4, 5] or $000000FF;
  Ball.Color[12, 5] := Ball.Color[12, 5] or $000000FF;
  Ball.Color[8, 7] := Ball.Color[8, 7] or $000000FF;
  Ball.Color[6, 10] := Ball.Color[6, 10] or $000000FF;
  Ball.Color[7, 10] := Ball.Color[7, 10] or $000000FF;
  Ball.Color[8, 10] := Ball.Color[8, 10] or $000000FF;
  Ball.Color[9, 10] := Ball.Color[9, 10] or $000000FF;
  Ball.Color[10, 10] := Ball.Color[10, 10] or $000000FF;
  //white line
  Ball.Color[0, 29] := $00FFFFFF;
  Ball.Color[0, 28] := $00FFFFFF;
  Ball.Color[0, 27] := $00FFFFFF;
  Ball.Color[0, 26] := $00FFFFFF;
  Ball.Color[0, 25] := $00FFFFFF;
  Ball.Color[0, 24] := $00FFFFFF;
  Ball.Color[0, 23] := $00FFFFFF;
  Ball.Color[0, 22] := $00FFFFFF;
  Ball.Color[0, 21] := $00FFFFFF;
  Ball.Color[0, 20] := $00FFFFFF;
  //green line
  Ball.Color[10, 29] := $0000FF00;
  Ball.Color[10, 28] := $0000FF00;
  Ball.Color[10, 27] := $0000FF00;
  Ball.Color[10, 26] := $0000FF00;
  Ball.Color[10, 25] := $0000FF00;
  Ball.Color[10, 24] := $0000FF00;
  Ball.Color[10, 23] := $0000FF00;
  Ball.Color[10, 22] := $0000FF00;
  Ball.Color[10, 21] := $0000FF00;
  Ball.Color[10, 20] := $0000FF00;
  //yellow line
  Ball.Color[0, 20] := $0000F0F0;
  Ball.Color[1, 20] := $0000F0F0;
  Ball.Color[2, 20] := $0000F0F0;
  Ball.Color[3, 20] := $0000F0F0;
  Ball.Color[4, 20] := $0000F0F0;
  Ball.Color[5, 20] := $0000F0F0;
  Ball.Color[6, 20] := $0000F0F0;
  Ball.Color[7, 20] := $0000F0F0;
  Ball.Color[8, 20] := $0000F0F0;
  Ball.Color[9, 20] := $0000F0F0;
  Ball.Color[10, 20] := $0000F0F0;
  //blue point
  PxorDXVertexClassic(Ball.Vertex[5, 23])^.Color := GetCol($00FF0000);
  { Ball.Vertex[5, 23] has classic vertex structure,
    so you can convert it to PxorDXVertexClassic and set color directly,
    but its no TColor, its a TxorDXColor, use GetCol !!!}

  //start
  Camera.SetStandard;
  Camera.Activate;
  Scene.StartLooping(Draw);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  //free in inverted order of creation
  if Assigned(Scene) then Scene.StopLooping;
  if Assigned(Ball) then FreeAndNil(Ball);
  if Assigned(Camera) then FreeAndNil(Camera);
  if Assigned(Scene) then FreeAndNil(Scene);
end;

//repeated drawing routine
procedure TForm1.Draw(Sender: TObject);
begin
  Scene.Clear;
  Ball.Insert;
  Ball.RotateX(-0.06);
  Ball.Draw;
end;

initialization

  xorDXThrowAllOtherExceptions := True;
  xorDXThrowCameraTransformationExceptions := False;
  xorDXThrowIndexSizeException := True;
  xorDXThrowCapsException := True;

end.
