unit FontMain;

interface

uses
  SysUtils, Forms,
  xorDX8;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    Scene: TxorDXScene;
    Font1: TxorDXFont;
    Font2: TxorDXFont;
    Font3: TxorDXFont;
    procedure Draw(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses Windows, Graphics, Classes;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  F: TLogFont;
begin
  with F do
    begin
    lfHeight := -24 * GetDeviceCaps(Canvas.Handle, LOGPIXELSY) div 72; //pointsize = 24 to pixelsize
    lfWidth := 50;
    lfEscapement := 330;
    lfOrientation := 330;
    lfWeight := FW_THIN	;
    lfItalic := 0;
    lfUnderline := 0;
    lfStrikeOut := 0;
    lfCharSet := DEFAULT_CHARSET;
    lfOutPrecision := OUT_CHARACTER_PRECIS;
    lfClipPrecision := CLIP_DEFAULT_PRECIS;
    lfQuality := DEFAULT_QUALITY;
    lfPitchAndFamily := DEFAULT_PITCH;
    lfFaceName := 'Courier New';
    end;
  //creation
  Scene  := TxorDXScene.Create(Handle);
  Font1 := TxorDXFont.Create(Scene);
//  Font2 := TxorDXFont.Create(Scene, 'Times New Roman', 52, [fsBold, fsUnderline]);
  Font2 := TxorDXFont.Create(Scene, 'Arial', 52, [fsBold, fsUnderline]);
  Font3 := TxorDXFont.Create(Scene, F);
  Scene.CreateBuffers;
  Scene.OnDraw := Draw; //set draw routine
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  //free in inverted order of creation
  if Assigned(Scene) then Scene.StopLooping;
  if Assigned(Font3) then FreeAndNil(Font3);
  if Assigned(Font2) then FreeAndNil(Font2);
  if Assigned(Font1) then FreeAndNil(Font1);
  if Assigned(Scene) then FreeAndNil(Scene);
end;

//repeated drawing routine
procedure TForm1.Draw(Sender: TObject);
begin
  Scene.Clear;
  Font1.TextOut(Rect(0, 10, 300,230), DT_LEFT or DT_TOP, clBlack, 1.0, 'Font1' + Enter + 'StandardFont' + Enter + 'with LineBreak');
  Font2.TextOut(Rect(0, 10, 900,230), DT_CENTER or DT_BOTTOM, clBlack, 1.0, 'Font2');
  Font2.TextOut(Rect(0,200, 900,330), DT_CENTER or DT_BOTTOM, clRed, 1.0, 'with some formats and');
  Font2.TextOut(Rect(0,200, 900,380), DT_CENTER or DT_BOTTOM, clBlack, 0.7, 'different Alpha values');
  Font2.TextOut(Rect(0,200, 900,400), DT_CENTER or DT_BOTTOM, clBlack, 0.5, 'different Alpha values');
  Font2.TextOut(Rect(0,200, 900,425), DT_CENTER or DT_BOTTOM, clBlack, 0.3, 'different Alpha values');
  Font2.TextOut(Rect(0,200, 900,455), DT_CENTER or DT_BOTTOM, clBlack, 0.1, 'different Alpha values');
  Font2.TextOut(Rect(0,200, 900,490), DT_CENTER or DT_BOTTOM, clBlack, 0.05, 'different Alpha values');
  Font3.TextOut(Rect(710,0, 1100,230), DT_CENTER or DT_BOTTOM or DT_SINGLELINE, clBlue, 1.0, 'Font3');
  Font3.TextOut(Rect(610,0, 1300,450), DT_BOTTOM or DT_SINGLELINE, clGreen, 1.0, 'with lots of');
  Font3.TextOut(Rect(610,0, 1300,420), DT_CENTER or DT_BOTTOM or DT_SINGLELINE, clGreen, 1.0, 'params');
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  Scene.Draw;
end;

initialization

  xorDXThrowAllOtherExceptions := True;
  xorDXThrowCameraTransformationExceptions := False;
  xorDXThrowIndexSizeException := True;
  xorDXThrowCapsException := True;

end.
